#=======================additional function===========

import json
import re
#import httplib2
import sys,traceback
from ExceptionHandling import ExceptionHandling


class AdditionalFunctions():

    def __init__(self,qc_url):
        self.qc_url=qc_url

    def QC_Information_API_Formation(self,json_string):
        latest_attempt_no=len(json_string["calibrationAttempts"])
        pf_sensor_id=json_string["calibrationAttempts"][latest_attempt_no-1]["sensorId"]
        forming_api= self.qc_url+pf_sensor_id
        http=httplib2.Http()
        status,response=http.request(forming_api)
        qc_information_api_data=json.loads(response)
        return {"qc_information_api_data_pf" : qc_information_api_data, "qc_information_api": forming_api}
            
    def Get_Parameters_PF(self,qc_information_api_data_pf,qc_information_api):
        if "cttype" in qc_information_api_data_pf:
            cttype= float(re.sub("A","",qc_information_api_data_pf["cttype"]))    
        else:
            cttype=None    
        if "isostat" in qc_information_api_data_pf:
            isostat=qc_information_api_data_pf["isostat"]
        else:
            isostat= None
        new_exception_handling=ExceptionHandling()
        numeric_inputs_exception_indicator_cttype=new_exception_handling.Numeric_Input_Type_Checking([cttype])
        character_inputs_exception_indicator_isostat=new_exception_handling.Character_Input_Type_Checking([isostat])
        
        return {"cttype" : cttype, "isostat" : isostat, "cttype_exception_indicator" : numeric_inputs_exception_indicator_cttype,
                    
                    "isostat_exception_indicator" : character_inputs_exception_indicator_isostat, "final_cttype_api" : qc_information_api}

