import sys
import time
import threading
import fnmatch
from queue import Queue
from pynovatec.events import EventPost, EventRegisterListener,EventUnregisterListener,EventQueueShutdown, EventListener, Events



class EventTest1(Events):                                 
    def __init__(self,*args,**kwargs):                    
        super().__init__(*args,**kwargs)                  
                                                          
class EventTest2(EventTest1):                             
    pass                                                  
                                                          
                                                          
class Listener(EventListener):                            
    def __init__(self,*args,**kwargs):                                   
        super().__init__(*args,**kwargs)                                
        self.events.append(EventTest1)                    
                                                          
    def handle(self,msg):                                 
        print("Listener run: ",msg.data)                  
                                                          
class Listener2(EventListener):                           
    def __init__(self,*args,**kwargs):                                   
        super().__init__(*args,**kwargs)
        self.events.append(EventTest1)                    
                                                          
    def handle(self,msg):                                 
        print("Listener2 run: ",msg.data)                 



class AllListener(EventListener):                       
    def __init__(self,*args,**kwargs):
        super().__init__(*args,**kwargs)
        self.events=[Events]
                                                     
    def handle(self,msg):                            
        print("All Listener run: ",msg.data)             

class DynamicListener(EventListener):                       
    def __init__(self,*args,**kwargs):
        super().__init__(*args,**kwargs)
                                                     
    def handle(self,msg):                            
        print("Dynamic Listener run: ",msg.data)             



if __name__ == '__main__':
    l2 = Listener2()
    EventRegisterListener(Listener())
    EventRegisterListener(DynamicListener(),events=[EventTest1])
    #EventRegisterListener(Listener2())
    EventRegisterListener(l2)
    EventRegisterListener(AllListener())
    EventPost(EventTest1("Hello"))

    time.sleep(1)
    EventUnregisterListener(l2)

    time.sleep(2)
    EventPost(EventTest2("..World!"))
    time.sleep(2)
    EventQueueShutdown()

