from PFSensorCollector import PFSensorCollector
from ZmqCollection import ZmqCollection
from VacSensorCollector import set_csv_path, set_profile_path
from pynovatec.events import EventQueueShutdown
import sys
import getopt


ports=1

try:
    opts, args = getopt.getopt(sys.argv[1:],"p:")
except getopt.GetoptError:
    print("Error: Error in set options: ")
for opt,arg in opts:
    if opt == "-p":
        ports = int(arg)



collectors = []
for port in range(ports):
    print("Port: ",port)
    collector = PFSensorCollector("PF","B8:27:EB:0B:E3:F2",port+1)
    collector.set_content("273.5,34.7,271,34.7,271,34.7")
    collectors.append(collector)
#collector = PFSensorCollector("PF","B8:27:EB:0B:E3:F2",2)
#collectors.append(collector)

set_csv_path("/tmp/log/calibration/csv/")
set_profile_path("/tmp/log/calibration/profile/")


zmq = ZmqCollection(None,collectors=collectors)

zmq.start()

zmq.join()

#EventQueueShutdown()

